<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title> Карлов Илья M33031 </title>
    <meta name="keywords" content="porfolion, laboratoty works, student">
    <meta name="description" content="Сайт-портфолио ученика третьего курса университета ИТМО, выполненный в рамках лабораторной работы">
    <!-- <link rel="stylesheet" href="../css/outline-prototype-label.css" type="text/css"> -->
    <link rel="stylesheet" href="./css/outline.css" type="text/css">
</head>

<body>
    <header>
        <!-- Добавить ссылки на разделы по id -->
        <nav class="navigation">
            <p><a href="#contact">Контакты</a></p>
            <p><a href="#skills">Навыки</a></p>
            <p><a href="#projects">Проекты</a></p>
            <p><a href="#start-page">В&nbspначало</a></p>
        </nav>
    </header>

    <main>

        <section class="start-page" id="start-page">
            <!-- <img src="pic/sunset-home-office-working-with-laptop-on-the-garden-picjumbo-com.jpg">                
                     -->
            <h2>Портфолио</h2>
            <h2>Карлов Илья</h2>
            <p><strong>ИТМО, ФИТИП, ИС, 3 курс</strong></p>
        </section>

        <section class="projects" id="projects">
            <h3>Проекты</h3>
            <ul>
                <li>
                    <h4>Расширение для Intellij IDEA </h4>
                    <p>Расширение, позволяющее нажатим комбинации клавиш открыть в браузере сайт с примерами использования класса, который вы выделили </p><br><a href="https://github.com/Ikar108/Code_Examples_Plugin" target="_blank">Plugin</a></li>
                <li>
                    <h4>Учёт и анализ посещаемости </h4>
                    <p>Приложение (без сервисного слоя, в основном взаимодействие с БД), для приложения по учёту онлайн посещаемости и её анализу </p><br><a href="https://github.com/Ikar108/Practice1" target="_blank">Analysis of attendance</a></li>
                <li>
                    <h4>Данный проект</h4>
                    <p>Реализацию этого сайта также можно найти в моем профиле <a href="https://github.com/Ikar108" target="_blank">Github</a></p><br><a href="https://github.com/Ikar108/Web_Practice_2021" target="_blank">Portfolio</a></li>
            </ul>
        </section>



        <section class="skills" id="skills">
            <!--<h3>Навыки</h3>
                 <dl>
                    <div><dt><h4>Java</h4></dt><br> <dd>Изучение синтаксиса и ООП на этом языке в университете, а также обучаясь на сайте <a href="https://javarush.ru/users/2380109" target="_blank">javarush.ru</a></dd></div>
                    <div><dt><h4>C/C++</h4></dt><br> <dd>Два семестра изучения данных языков. Реализация лабораторных работ в том числе и по смежным предметам (Алгоритмы и структуры данных)</dd></div>
                    <div><dt><h4>Python</h4></dt><br> <dd>Изучение этого языка в рамках курсов Машинного обучение и Методов оптимизации</dd></div>
                </dl> -->
            <table>
                <tr>
                    <th>
                        <h3>Навыки</h3>
                    </th>
                    <th>
                        <h4>Описание</h4>
                    </th>
                </tr>
                <tr class="class1">
                    <td>
                        <h4>Java</h4>
                    </td>
                    <td>Изучение синтаксиса и ООП на этом языке в университете, а также обучаясь на сайте <a href="https://javarush.ru/users/2380109" target="_blank">javarush.ru</a></td>
                </tr>
                <tr>
                    <td>
                        <h4>C/C++</h4>
                    </td>
                    <td>Два семестра изучения данных языков. Реализация лабораторных работ в том числе и по смежным предметам (Алгоритмы и структуры данных)</td>
                </tr>
                <tr class="class1">
                    <td>
                        <h4>Python</h4>
                    </td>
                    <td>Изучение этого языка в рамках курсов Машинного обучение и Методов оптимизации</td>
                </tr>

            </table>
        </section>

        <!-- Настроить css, чтобы следующие фразы доги как бы говорили -->
        <section class="adage">
            <q><i><b>Гарантированно, как смерть</b></i></q>
            <sub><cite>Бенгальская поговорка</cite></sub>
        </section>

        <section class="char-picture">
            <pre>
                   '         ▄              ▄',,'▄              ▄         '
                  '        ▌▒█           ▄▀▒▌',,'▌▒▀▄           █▒▌        '
                  '        ▌▒▒█        ▄▀▒▒▒▐',,'▐▒▒▒▀▄        █▒▒▌        '
                  '       ▐▄▀▒▒▀▀▀▀▄▄▄▀▒▒▒▒▒▐',,'▐▒▒▒▒▒▀▄▄▄▀▀▀▀▒▒▀▄▐       '
                  '     ▄▄▀▒░▒▒▒▒▒▒▒▒▒█▒▒▄█▒▐',,'▐▒█▄▒▒█▒▒▒▒▒▒▒▒▒░▒▀▄▄     '
                  '   ▄▀▒▒▒░░░▒▒▒░░░▒▒▒▀██▀▒▌',,'▌▒▀██▀▒▒▒░░░▒▒▒░░░▒▒▒▀▄   '
                 '  ▐▒▒▒▄▄▒▒▒▒░░░▒▒▒▒▒▒▒▀▄▒▒▌',,'▌▒▒▄▀▒▒▒▒▒▒▒░░░▒▒▒▒▄▄▒▒▒▐  '
                 '  ▌░░▌█▀▒▒▒▒▒▄▀█▄▒▒▒▒▒▒▒█▒▐',,'▐▒█▒▒▒▒▒▒▒▄█▀▄▒▒▒▒▒▀█▌░░▌  '
                ' ▐░░░▒▒▒▒▒▒▒▒▌██▀▒▒░░░▒▒▒▀▄▌',,'▌▄▀▒▒▒░░░▒▒▀██▌▒▒▒▒▒▒▒▒░░░▐ '
                ' ▌░▒▄██▄▒▒▒▒▒▒▒▒▒░░░░░░▒▒▒▒▌',,'▌▒▒▒▒░░░░░░▒▒▒▒▒▒▒▒▒▄██▄▒░▌ '
                '▌▒▀▐▄█▄█▌▄░▀▒▒░░░░░░░░░░▒▒▒▐',,'▐▒▒▒░░░░░░░░░░▒▒▀░▄▌█▄█▄▐▀▒▌'
               '▐▒▒▐▀▐▀▒░▄▄▒▄▒▒▒▒▒▒░▒░▒░▒▒▒▒▌',,'▌▒▒▒▒░▒░▒░▒▒▒▒▒▒▄▒▄▄░▒▀▐▀▐▒▒▐'
                '▐▒▒▒▀▀▄▄▒▒▒▄▒▒▒▒▒▒▒▒░▒░▒░▒▒▐',,'▐▒▒░▒░▒░▒▒▒▒▒▒▒▒▄▒▒▒▄▄▀▀▒▒▒▐'
                ' ▌▒▒▒▒▒▒▀▀▀▒▒▒▒▒▒░▒░▒░▒░▒▒▒▌',,'▌▒▒▒░▒░▒░▒░▒▒▒▒▒▒▀▀▀▒▒▒▒▒▒▌ '
                 ' ▐▒▒▒▒▒▒▒▒▒▒▒▒▒▒░▒░▒░▒▒▄▒▒▐',,'▐▒▒▄▒▒░▒░▒░▒▒▒▒▒▒▒▒▒▒▒▒▒▒▐ '
                 '  ▀▄▒▒▒▒▒▒▒▒▒▒▒░▒░▒░▒▄▒▒▒▒▌',,'▌▒▒▒▒▄▒░▒░▒░▒▒▒▒▒▒▒▒▒▒▒▄▀  '
                  '    ▀▄▒▒▒▒▒▒▒▒▒▒▄▄▄▀▒▒▒▒▄▀',,'▀▄▒▒▒▒▀▄▄▄▒▒▒▒▒▒▒▒▒▒▄▀    '
                </pre>
        </section>

        <section class="formula">
            <h3>Формула успеха:</h3>
            <p>Сделать <b><i>идеально</i></b>, значит сделать <u>максимум</u> <i>за доступное время</i>;</p>
        </section>

        <section class="code">
            <h3>Automatically balanced binary tree</h3>
            <pre>
                    <code>
                    struct SList {
                        int num;
                        SList *left = nullptr;
                        SList *right = nullptr;
                        unsigned char height;

                        explicit SList(const int num) :
                             left(nullptr), right(nullptr), num(num), height(1) {};
                    };


                    unsigned char height(SList *node) {
                        return node ? node->height : (unsigned char) 0;
                    }

                    void Trueheight(SList *node) {
                        unsigned char hl = height(node->left);
                        unsigned char hr = height(node->right);
                        node->height = (hl > hr ? hl : hr) + (unsigned char) 1;
                    }

                    int bfact(SList *node) {
                        return height(node->right) - height(node->left);
                    }

                    SList *Rrot(SList *node) {
                        SList *nd = node->left;
                        node->left = nd->right;
                        nd->right = node;
                        Trueheight(node);
                        Trueheight(nd);
                        return nd;
                    }

                    SList *Lrot(SList *node) {
                        SList *nd = node->right;
                        node->right = nd->left;
                        nd->left = node;
                        Trueheight(node);
                        Trueheight(nd);
                        return nd;
                    }

                    SList *balance(SList *node) {
                        if (!node)
                            return nullptr;
                        Trueheight(node);
                        if (bfact(node) == 2) {
                            if (bfact(node->right) < 0)
                                node->right = Rrot(node->right);
                            return Lrot(node);
                        } else if (bfact(node) == -2) {
                            if (bfact(node->left) > 0)
                                node->left = Lrot(node->left);
                            return Rrot(node);
                        }
                        return node;
                    }

                    SList *insert(SList *node, int num) {
                        if (!node) return new SList(num);
                        if (node->num < num) {
                            node->right = insert(node->right, num);
                        } else {
                            node->left = insert(node->left, num);
                        }
                        return balance(node);
                    }

                    SList *del(SList *node, int num) {
                        if (!node) return nullptr;
                        if (node->num < num) {
                            node->right = del(node->right, num);
                        } else if (node->num > num) {
                            node->left = del(node->left, num);
                        } else {
                            if (!(node->left || node->right))
                                return nullptr;
                            else if (!node->left)
                                return node->right;
                            else {
                                SList *nd = node->left;
                                while (nd->right)
                                    nd = nd->right;
                                node->num = nd->num;
                                node->left = balance(del(node->left, nd->num));
                            }
                        }
                        return balance(node);
                    }

                    int find(SList *node, int num) {
                        while (node) {
                            if (node->num > num)
                                node = node->left;
                            else if (node->num < num)
                                node = node->right;
                            else
                                return 1;
                        }
                        return 0;

                    }
                    </code>
                </pre>
        </section>

    </main>

    <footer>
        <section class="contact" id="contact">
            <p>
                <p><a href="https://vk.com/my_vk">VK</a></p>
                <p><a href="https://t.me/my_tg">Telegram</a> </p>
                <p><a href="mailto:my_mmmmail@gig.glhf" target="_blank">E-mail</a></p>
        </section>

    </footer>
</body>

</html>